/*
    Парус 8 - Панели мониторинга - РО - Редактор настройки регламентированного отчёта
    Обще стили и константы
*/

//---------
//Константы
//---------

//Допустимые варианты сортировки строк/граф
const COL_ROW_ORDER = [
    { name: "Номер", value: 0 },
    { name: "Код", value: 1 },
    { name: "Мнемокод", value: 2 }
];

//Типовые цвета
const BG_GRAY = "#e3e3e3";
const BG_BLUE = "#1976d210";

//Типовые размеры шрифтов
const FONT_SIZE_LARGE = "0.85rem";
const FONT_SIZE_SMALL = "0.75rem";

//Стили
const STYLES = {
    TOOLBAR: { position: "absolute", right: 0, backgroundColor: BG_BLUE },
    LINK: { component: "button", cursor: "pointer", width: "-webkit-fill-available" },
    FONT_DATA_GRID: { fontSize: FONT_SIZE_SMALL },
    FONT_MARK_CARD_HEAD: { fontSize: FONT_SIZE_LARGE },
    FONT_MARK_CARD_BODY: { fontSize: FONT_SIZE_SMALL },
    BG_DATA_GRID_HEAD_CELL: { backgroundColor: BG_GRAY },
    BG_DATA_GRID_DATA_CELL: { backgroundColor: BG_GRAY },
    BG_MARK_CARD: { backgroundColor: BG_BLUE },
    BORDER_DATA_GRID_HEAD_CELL: { border: "1px solid white" },
    BORDER_DATA_GRID_DATA_CELL: { borderBottom: `1px solid ${BG_GRAY}` }
};

//----------------
//Интерфейс модуля
//----------------

export { COL_ROW_ORDER, STYLES };
