/*
    Парус 8 - Панели мониторинга - РО - Редактор настройки регламентированного отчёта
    Компонент панели: Диалог сортировки
*/

//---------------------
//Подключение библиотек
//---------------------

import React from "react"; //Классы React
import PropTypes from "prop-types"; //Контроль свойств компонента
import { Form } from "./form"; //Типовая форма
import { COL_ROW_ORDER } from "../common"; //Обще стили и константы

//-----------
//Тело модуля
//-----------

//Диалог сортировки
const DialogOrder = ({ rowOrder = 0, columnOrder = 0, onOk, onCancel }) => {
    //Нажатие на кнопку "Ok"
    const handleOk = values => onOk && onOk({ ...values });

    //Нажатие на кнопку "Отмена"
    const handleCancel = () => onCancel && onCancel();

    //Генерация содержимого
    return (
        <Form
            title={"Сортировка"}
            fields={[
                { elementCode: "rowOrder", elementValue: rowOrder, labelText: "Строки", list: COL_ROW_ORDER },
                { elementCode: "columnOrder", elementValue: columnOrder, labelText: "Графы", list: COL_ROW_ORDER }
            ]}
            onOk={handleOk}
            onCancel={handleCancel}
        />
    );
};

//Контроль свойств - Диалог сортировки
DialogOrder.propTypes = {
    rowOrder: PropTypes.number,
    columnOrder: PropTypes.number,
    onOk: PropTypes.func,
    onCancel: PropTypes.func
};

//----------------
//Интерфейс модуля
//----------------

export { DialogOrder };
