/*
    Парус 8 - Панели мониторинга - РО - Редактор настройки регламентированного отчёта
    Компонент панели: Диалог добавления/исправления раздела
*/

//---------------------
//Подключение библиотек
//---------------------

import React from "react"; //Классы React
import PropTypes from "prop-types"; //Контроль свойств компонента
import { Form } from "./form"; //Типовая форма

//-----------
//Тело модуля
//-----------

//Диалог добавления/исправления раздела
const DialogSectionIU = ({ code = "", name = "", insert = true, onOk, onCancel }) => {
    //Нажатие на кнопку "Ok"
    const handleOk = values => onOk && onOk({ ...values });

    //Нажатие на кнопку "Отмена"
    const handleCancel = () => onCancel && onCancel();

    //Генерация содержимого
    return (
        <Form
            title={`${insert === true ? "Добавление" : "Исправление"} раздела`}
            fields={[
                { elementCode: "code", elementValue: code, labelText: "Мнемокод" },
                { elementCode: "name", elementValue: name, labelText: "Наименование" }
            ]}
            onOk={handleOk}
            onCancel={handleCancel}
        />
    );
};

//Контроль свойств - Диалог добавления/исправления раздела
DialogSectionIU.propTypes = {
    code: PropTypes.string,
    name: PropTypes.string,
    insert: PropTypes.bool,
    onOk: PropTypes.func,
    onCancel: PropTypes.func
};

//----------------
//Интерфейс модуля
//----------------

export { DialogSectionIU };
