/*
    Парус 8 - Панели мониторинга - РО - Редактор настройки регламентированного отчёта
    Компонент панели: Панель инструментов показателей
*/

//---------------------
//Подключение библиотек
//---------------------

import React from "react"; //Классы React
import PropTypes from "prop-types"; //Контроль свойств компонента
import { Stack, Icon, IconButton } from "@mui/material"; //Интерфейсные компоненты

//---------
//Константы
//---------

//Стили
const STYLES = {
    CONTAINER: { width: "100%" }
};

//-----------
//Тело модуля
//-----------

//Панель инструментов показателей
const MarksToolbar = ({ onAdd, onRefresh, onOrder, onHelp }) => {
    //Формирование представления
    return (
        <Stack direction={"row"} alignItems={"center"} justifyContent={"center"} sx={STYLES.CONTAINER}>
            <IconButton title={"Добавить показатель"} onClick={onAdd}>
                <Icon>add</Icon>
            </IconButton>
            <IconButton title={"Обновить показатели"} onClick={onRefresh}>
                <Icon>refresh</Icon>
            </IconButton>
            <IconButton title={"Порядок сортировки показателей"} onClick={onOrder}>
                <Icon>sort</Icon>
            </IconButton>
            <IconButton title={"Легенда"} onClick={onHelp}>
                <Icon>help</Icon>
            </IconButton>
        </Stack>
    );
};

//Контроль свойств - Панель инструментов показателей
MarksToolbar.propTypes = {
    onAdd: PropTypes.func.isRequired,
    onRefresh: PropTypes.func.isRequired,
    onOrder: PropTypes.func.isRequired,
    onHelp: PropTypes.func.isRequired
};

//----------------
//Интерфейс модуля
//----------------

export { MarksToolbar };
