create or replace package PKG_P8PANELS_RRPCONFED as

  /*      */
  procedure RRPCONFSCTNMRK_INSERT
  (
    NPRN                    in number,   -- .  
    SCODE                   in varchar2, --   
    SNAME                   in varchar2, --   
    NRRPROW                 in number,   -- .  
    SRRPROW                 in varchar2, --   (,   .  )
    SRRPVERSION_ROW         in varchar2, --    (,   .  )
    NRRPCOLUMN              in number,   -- .  
    SRRPCOLUMN              in varchar2, --  
    SRRPVERSION_COLUMN      in varchar2, --   
    NRN                     out number   -- .   
  );
  
  /*      */
  procedure RRPCONFSCTNMRK_UPDATE
  (
    NRN                     in number,   -- .               
    SCODE                   in varchar2, --   
    SNAME                   in varchar2, --   
    SRRPROW                 in varchar2, --  
    SRRPVERSION_ROW         in varchar2, --   
    SRRPCOLUMN              in varchar2, --  
    SRRPVERSION_COLUMN      in varchar2  --   
  );
  
  /*      */
  procedure RRPCONFSCTNMRK_DELETE
  (        
    NRN                     in number   -- .   
  );
  
  /*     */
  procedure RRPCONFSCTN_GET
  (
    NRRPCONFSCTN            in number,      -- .      
    NROW_ORDER              in number := 0, --    (0 -  , 1 -  , 2 -  )
    NCOL_ORDER              in number := 0, --    (0 -  , 1 -  , 2 -  )
    COUT                    out clob        --  
  );

  /*     */
  procedure RRPCONFSCTN_INSERT
  (
    NPRN                    in number,   -- .     
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2, -- 
    NRN                     out number   -- .   
  );
  
  /*     */
  procedure RRPCONFSCTN_UPDATE
  (
    NRN                     in number,   -- .  
    SCODE                   in varchar2, --  
    SNAME                   in varchar2  --  
  );
  
  /*     */
  procedure RRPCONFSCTN_DELETE
  (
    NRN                     in number   -- .  
  );
  
  /*      */
  procedure RRPCONF_GET
  (
    NRRPCONF                in number,  -- .     
    COUT                    out clob    --  
  );
  
end PKG_P8PANELS_RRPCONFED;
/
create or replace package body PKG_P8PANELS_RRPCONFED as

  /*  -     */
  NSECTION_NAME_MAX_LEN     constant PKG_STD.TNUMBER := 100; --       ()
  
  /*  -       */
  NMRKS_DG_COL_WIDTH        constant PKG_STD.TNUMBER := 250; --   ()
  
  /*  -        */
  SPRM_MASK_ACC_DC          constant PKG_STD.TSTRING := '_'; --    " "  " "
  SPRM_MASK_ACC             constant PKG_STD.TSTRING := '';         --    ""
  SPRM_MASK_ACC_WO_ANL      constant PKG_STD.TSTRING := '__'; --    ""   
  SPRM_MASK_DATE_FROM       constant PKG_STD.TSTRING := '_';       --    " "
  SPRM_MASK_DATE_TO         constant PKG_STD.TSTRING := '_';      --    " "
  SPRM_MASK_RRPCONF         constant PKG_STD.TSTRING := '';    --     
  
  /*  -   */
  SUNIT_RRPCONFSCTN         constant PKG_STD.TSTRING := 'RRPConfigSection';     --    
  SUNIT_RRPCONFSCTNMRK      constant PKG_STD.TSTRING := 'RRPConfigSectionMark'; --     
  
  /*  -   */
  SACTION_DELETE            constant PKG_STD.TSTRING := 'DELETE'; -- 
  
  /*     */
  function UTL_UNIT_ACTION_GET_ALLOW
  (
    NCOMPANY                in number,       -- .  
    NRN                     in number,       -- .  
    SUNIT                   in varchar2,     --   (.  SUNIT_*)
    SACTION                 in varchar2      --  (.  SACTION_*)   
  ) return                  number           --   (0 - , 1 - )
  is
    NRESULT                 PKG_STD.TNUMBER; --   (0 - , 1 - )
  begin
    /*   */
    case SUNIT
      /*     */
      when SUNIT_RRPCONFSCTN then
        /*    */
        case SACTION
          /*  */
          when SACTION_DELETE then
            begin
              /*    */
              P_RRPCONFSCTN_BASE_CHECK(SMODE => 'D',
                                       RREC  => GET_RRPCONFSCTN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRN));
              /*   -   */
              NRESULT := 1;
            exception
              /*     -   */
              when others then
                NRESULT := 0;
            end;
          /*   -   */
          else
            NRESULT := 0;
        end case;
      /*      */
      when SUNIT_RRPCONFSCTNMRK then
        /*    */
        case SACTION
          /*  */
          when SACTION_DELETE then
            begin
              /*    */
              P_RRPCONFSCTNMRK_BASE_CHECK(SMODE => 'D',
                                          RREC  => GET_RRPCONFSCTNMRK_ID(NFLAG_SMART => 0,
                                                                         NCOMPANY    => NCOMPANY,
                                                                         NRN         => NRN));
              /*   -   */
              NRESULT := 1;
            exception
              /*     -   */
              when others then
                NRESULT := 0;
            end;
          /*   -   */
          else
            NRESULT := 0;
        end case;
      /*   -   */
      else
        NRESULT := 0;
    end case;
    /*   */
    return NRESULT;
  end UTL_UNIT_ACTION_GET_ALLOW;
  
  /*         */
  function RRPCONFSCTNMRKCN_GET_ST
  (
    NSOURCE_TYPE            in number,       --  
    SSOURCE_UNIT            in varchar2      --  
  ) return                  varchar2         --     
  is
    SRESULT                 PKG_STD.TSTRING; --     
  begin
    /*     */
    case NSOURCE_TYPE
      when 0 then
        /*    */
        case SSOURCE_UNIT
          when 'EconomicOperations' then
            SRESULT := '';
          when 'DebitorsCreditorsAccounts' then
            SRESULT := '';
          when 'AccountsRemnants' then
            SRESULT := '';
          when 'ValuesRemnants' then
            SRESULT := '';
          when 'DebitorsCreditorsRemnants' then
            SRESULT := '';
          when 'Inventory' then
            SRESULT := '';
          when 'ItemsCards' then
            SRESULT := '';
          when 'OperCards' then
            SRESULT := '';
          when 'DeclarationIncome' then
            SRESULT := '';
          when 'RRPDocuments' then
            SRESULT := '';
          else
            SRESULT := null;
        end case;
      when 1 then
        SRESULT := '';
      when 2 then
        SRESULT := '';
      when 3 then
        SRESULT := '';
      when 4 then
        SRESULT := 'fx';
      else
        SRESULT := null;
    end case;
    /*   */
    return SRESULT;
  end RRPCONFSCTNMRKCN_GET_ST;
    
  /*        */
  function RRPCONFSCTNMRKCN_GET_SIGN
  (
    NSIGN                   in number        --   
  ) return                  varchar2         --      
  is
    SRESULT                 PKG_STD.TSTRING; --      
  begin
    /*   */
    case NSIGN
      when 0 then
        SRESULT := '+';
      when 1 then
        SRESULT := '-';
      else
        SRESULT := '+/-';
    end case;
    /*   */
    return SRESULT;
  end RRPCONFSCTNMRKCN_GET_SIGN;

  /*       */
  function RRPCONFSCTNMRKCN_GET_DESC
  (
    NCOMPANY                in number,                -- .  
    NRRPCONFSCTNMRKCN       in number                 -- .     
  ) return                  varchar2                  --  
  is
    SRESULT                 PKG_STD.TSTRING;          --  
    SCN_DESC                PKG_STD.TSTRING;          --    
    RREC                    RRPCONFSCTNMRKCN%rowtype; --     
    RRRPCONFSCTNMRK         RRPCONFSCTNMRK%rowtype;   --    
  
    /*     .    */
    function MARK_GET_CODE_BY_CN
    (
      NRRPCONFSCTNMRKCN     in number        -- .   
    ) return                varchar2         --  
    is
      SRESULT               PKG_STD.TSTRING; --  
    begin
      /*    */
      begin
        select M.CODE
          into SRESULT
          from RRPCONFSCTNMRKCN T,
               RRPCONFSCTNMRK   M
         where T.RN = NRRPCONFSCTNMRKCN
           and M.RN = T.PRN;
      exception
        when others then
          SRESULT := null;
      end;
      /*   */
      return SRESULT;
    end MARK_GET_CODE_BY_CN;
    
    /*     .    */
    function CONF_GET_CODE_BY_CN
    (
      NRRPCONFSCTNMRKCN     in number        -- .   
    ) return                varchar2         --    
    is
      SRESULT               PKG_STD.TSTRING; --    
    begin
      /*      */
      begin
        select C.CODE
          into SRESULT
          from RRPCONFSCTNMRKCN T,
               RRPCONFSCTNMRK   M,
               RRPCONF          C
         where T.RN = NRRPCONFSCTNMRKCN
           and M.RN = T.PRN
           and C.RN = M.RRPCONF;
      exception
        when others then
          SRESULT := null;
      end;
      /*   */
      return SRESULT;
    end CONF_GET_CODE_BY_CN;
    
    /*      */
    procedure MAKE_PRMS_BY_MASK
    (
      SPRMS_DESC            in out varchar2, --   
      NCOMPANY              in number,       -- .  
      NRRPCONFSCTNMRKCN     in number,       -- .   
      SMASK                 in varchar2      --  (.  SPRM_MASK_*)
    )
    is
      SDATE_FROM            PKG_STD.TSTRING; --   " "
      SDATE_TO              PKG_STD.TSTRING; --   " "
      DDATE_FROM            PKG_STD.TLDATE;  -- _
      SDATE_FROM_PATTERN    PKG_STD.TSTRING; -- __
      DDATE_TO              PKG_STD.TLDATE;  -- _
      SDATE_TO_PATTERN      PKG_STD.TSTRING; -- __
      SACCOUNT_DEBIT        PKG_STD.TSTRING; -- _
      SANALYTIC_DEBIT1      PKG_STD.TSTRING; -- 1_
      SANALYTIC_DEBIT2      PKG_STD.TSTRING; -- 2_
      SANALYTIC_DEBIT3      PKG_STD.TSTRING; -- 3_
      SANALYTIC_DEBIT4      PKG_STD.TSTRING; -- 4_
      SANALYTIC_DEBIT5      PKG_STD.TSTRING; -- 5_
      SACCOUNT_CREDIT       PKG_STD.TSTRING; -- _
      SANALYTIC_CREDIT1     PKG_STD.TSTRING; -- 1_
      SANALYTIC_CREDIT2     PKG_STD.TSTRING; -- 2_
      SANALYTIC_CREDIT3     PKG_STD.TSTRING; -- 3_
      SANALYTIC_CREDIT4     PKG_STD.TSTRING; -- 4_
      SANALYTIC_CREDIT5     PKG_STD.TSTRING; -- 5_
      SACCOUNT              PKG_STD.TSTRING; -- 
      SANALYTIC1            PKG_STD.TSTRING; -- 1
      SANALYTIC2            PKG_STD.TSTRING; -- 2
      SANALYTIC3            PKG_STD.TSTRING; -- 3
      SANALYTIC4            PKG_STD.TSTRING; -- 4
      SANALYTIC5            PKG_STD.TSTRING; -- 5
      SRRPCONF              PKG_STD.TSTRING; -- 
      NRRPCONF_RD           PKG_STD.TNUMBER; -- _
      SMARK_CODE            PKG_STD.TSTRING; -- 
      NMARK_CODE_RD         PKG_STD.TNUMBER; -- _
      SMARK_ROW_CODE        PKG_STD.TSTRING; -- _
      SMARK_COL_CODE        PKG_STD.TSTRING; -- _
    begin
      /*       */
      case SMASK
        /* " "  " " */
        when SPRM_MASK_ACC_DC then
          /*   -   */
          SACCOUNT_DEBIT := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                     NPRN     => NRRPCONFSCTNMRKCN,
                                                                     SPARAM   => PKG_RRPCONFSCTNMRKCN.SACCOUNT_DEBIT_P);
          /*   -   1  */
          SANALYTIC_DEBIT1 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_DEBIT1_P);
          /*   -   2  */
          SANALYTIC_DEBIT2 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_DEBIT2_P);
          /*   -   3  */
          SANALYTIC_DEBIT3 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_DEBIT3_P);
          /*   -   4  */
          SANALYTIC_DEBIT4 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_DEBIT4_P);
          /*   -   5  */
          SANALYTIC_DEBIT5 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_DEBIT5_P);
          /*   -   */
          SACCOUNT_CREDIT := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                      NPRN     => NRRPCONFSCTNMRKCN,
                                                                      SPARAM   => PKG_RRPCONFSCTNMRKCN.SACCOUNT_CREDIT_P);
          /*   -   1  */
          SANALYTIC_CREDIT1 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                        NPRN     => NRRPCONFSCTNMRKCN,
                                                                        SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_CREDIT1_P);
          /*   -   2  */
          SANALYTIC_CREDIT2 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                        NPRN     => NRRPCONFSCTNMRKCN,
                                                                        SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_CREDIT2_P);
          /*   -   3  */
          SANALYTIC_CREDIT3 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                        NPRN     => NRRPCONFSCTNMRKCN,
                                                                        SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_CREDIT3_P);
          /*   -   4  */
          SANALYTIC_CREDIT4 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                        NPRN     => NRRPCONFSCTNMRKCN,
                                                                        SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_CREDIT4_P);
          /*   -   5  */
          SANALYTIC_CREDIT5 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                        NPRN     => NRRPCONFSCTNMRKCN,
                                                                        SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC_CREDIT5_P);
          /*     */
          if ((SACCOUNT_DEBIT is not null) or (SANALYTIC_DEBIT1 is not null) or (SANALYTIC_DEBIT2 is not null) or
             (SANALYTIC_DEBIT3 is not null) or (SANALYTIC_DEBIT4 is not null) or (SANALYTIC_DEBIT5 is not null)) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SACCOUNT_DEBIT || '';
            /*     */
            SPRMS_DESC := SPRMS_DESC || '(' || SANALYTIC_DEBIT1 || ',' || SANALYTIC_DEBIT2 || ',' || SANALYTIC_DEBIT3 || ',' ||
                          SANALYTIC_DEBIT4 || ',' || SANALYTIC_DEBIT5 || '),';
          end if;
          /*     */
          if ((SACCOUNT_CREDIT is not null) or (SANALYTIC_CREDIT1 is not null) or (SANALYTIC_CREDIT2 is not null) or
             (SANALYTIC_CREDIT3 is not null) or (SANALYTIC_CREDIT4 is not null) or (SANALYTIC_CREDIT5 is not null)) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SACCOUNT_CREDIT || ',';
            /*     */
            SPRMS_DESC := SPRMS_DESC || '(' || SANALYTIC_CREDIT1 || ',' || SANALYTIC_CREDIT2 || ',' ||
                          SANALYTIC_CREDIT3 || ',' || SANALYTIC_CREDIT4 || ',' || SANALYTIC_CREDIT5 || '),';
          end if;
        /* "" */
        when SPRM_MASK_ACC then
          /*   -  */
          SACCOUNT := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                               NPRN     => NRRPCONFSCTNMRKCN,
                                                               SPARAM   => PKG_RRPCONFSCTNMRKCN.SACCOUNT_P);
          /*   -   1 */
          SANALYTIC1 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC1_P);
          /*   -   2 */
          SANALYTIC2 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC2_P);
          /*   -   3 */
          SANALYTIC3 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC3_P);
          /*   -   4 */
          SANALYTIC4 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC4_P);
          /*   -   5 */
          SANALYTIC5 := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SANALYTIC5_P);
          /*    */
          if ((SACCOUNT is not null) or (SANALYTIC1 is not null) or (SANALYTIC2 is not null) or
             (SANALYTIC3 is not null) or (SANALYTIC4 is not null) or (SANALYTIC5 is not null)) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SACCOUNT || '';
            /*     */
            SPRMS_DESC := SPRMS_DESC || '(' || SANALYTIC1 || ',' || SANALYTIC2 || ',' || SANALYTIC3 || ',' ||
                          SANALYTIC4 || ',' || SANALYTIC5 || '),';
          end if;
        /* ""   */
        when SPRM_MASK_ACC_WO_ANL then
          /*   -  */
          SACCOUNT := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                               NPRN     => NRRPCONFSCTNMRKCN,
                                                               SPARAM   => PKG_RRPCONFSCTNMRKCN.SACCOUNT_P);
          /*     */
          if (SACCOUNT is not null) then
            /*     */
            SPRMS_DESC := SPRMS_DESC || ':' || SACCOUNT || ',';
          end if;
        /* " " */
        when SPRM_MASK_DATE_FROM then
          /*   -   */
          DDATE_FROM := PKG_RRPCONFSCTNMRKCN.PARAM_GET_DATE_VALUE(NCOMPANY => NCOMPANY,
                                                                  NPRN     => NRRPCONFSCTNMRKCN,
                                                                  SPARAM   => PKG_RRPCONFSCTNMRKCN.SDATE_FROM_P);
          /*   -   () */
          SDATE_FROM_PATTERN := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                         NPRN     => NRRPCONFSCTNMRKCN,
                                                                         SPARAM   => PKG_RRPCONFSCTNMRKCN.SDATE_FROM_PATTERN_P);
          /*  " " */
          SDATE_FROM := COALESCE(TO_CHAR(DDATE_FROM, 'dd.mm.yyyy'), SDATE_FROM_PATTERN);
          /*     */
          if (SDATE_FROM is not null) then
            /*    */
            SPRMS_DESC := SPRMS_DESC || ':' || SDATE_FROM || ',';
          end if;
        /* " " */
        when SPRM_MASK_DATE_TO then
          /*   -   */
          DDATE_TO := PKG_RRPCONFSCTNMRKCN.PARAM_GET_DATE_VALUE(NCOMPANY => NCOMPANY,
                                                                NPRN     => NRRPCONFSCTNMRKCN,
                                                                SPARAM   => PKG_RRPCONFSCTNMRKCN.SDATE_TO_P);
          /*   -   () */
          SDATE_TO_PATTERN := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                       NPRN     => NRRPCONFSCTNMRKCN,
                                                                       SPARAM   => PKG_RRPCONFSCTNMRKCN.SDATE_TO_PATTERN_P);
          /*  " " */
          SDATE_TO := COALESCE(TO_CHAR(DDATE_TO, 'dd.mm.yyyy'), SDATE_TO_PATTERN);
          /*     */
          if (SDATE_TO is not null) then
            /*    */
            SPRMS_DESC := SPRMS_DESC || ':' || SDATE_TO || ',';
          end if;
        /*    */
        when SPRM_MASK_RRPCONF then
          /*   -    */
          SRRPCONF := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                               NPRN     => NRRPCONFSCTNMRKCN,
                                                               SPARAM   => PKG_RRPCONFSCTNMRKCN.SRRPCONF_P);
          /*   -    () */
          NRRPCONF_RD := PKG_RRPCONFSCTNMRKCN.PARAM_GET_NUM_VALUE(NCOMPANY => NCOMPANY,
                                                                  NPRN     => NRRPCONFSCTNMRKCN,
                                                                  SPARAM   => PKG_RRPCONFSCTNMRKCN.SRRPCONF_RD_P);
          /*     */
          if (NRRPCONF_RD = 1) then
            /*     */
            SRRPCONF := CONF_GET_CODE_BY_CN(NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN);
          end if;
          /*   -   */
          SMARK_CODE := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                 NPRN     => NRRPCONFSCTNMRKCN,
                                                                 SPARAM   => PKG_RRPCONFSCTNMRKCN.SMARK_CODE_P);
          /*   -   () */
          NMARK_CODE_RD := PKG_RRPCONFSCTNMRKCN.PARAM_GET_NUM_VALUE(NCOMPANY => NCOMPANY,
                                                                    NPRN     => NRRPCONFSCTNMRKCN,
                                                                    SPARAM   => PKG_RRPCONFSCTNMRKCN.SMARK_CODE_RD_P);
          /*     */
          if (NMARK_CODE_RD = 1) then
            /*     */
            SMARK_CODE := MARK_GET_CODE_BY_CN(NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN);
          end if;
          /*   -    */
          SMARK_ROW_CODE := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                     NPRN     => NRRPCONFSCTNMRKCN,
                                                                     SPARAM   => PKG_RRPCONFSCTNMRKCN.SMARK_ROW_CODE_P);
          /*   -    */
          SMARK_COL_CODE := PKG_RRPCONFSCTNMRKCN.PARAM_GET_STR_VALUE(NCOMPANY => NCOMPANY,
                                                                     NPRN     => NRRPCONFSCTNMRKCN,
                                                                     SPARAM   => PKG_RRPCONFSCTNMRKCN.SMARK_COL_CODE_P);
          /*    */
          if (SRRPCONF is not null) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SRRPCONF || ',';
          end if;
          /*     */
          if (SMARK_CODE is not null) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SRRPCONF || ',';
          end if;
          /*     */
          if (SMARK_ROW_CODE is not null) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SMARK_ROW_CODE || ',';
          end if;
          /*     */
          if (SMARK_COL_CODE is not null) then
            /*  */
            SPRMS_DESC := SPRMS_DESC || ':' || SMARK_COL_CODE || ',';
          end if;
        else
          /*   */
          null;
      end case;
    end MAKE_PRMS_BY_MASK;
    
    /*          */
    function SOURCE_UNIT_GET_PRMS
    (
      NCOMPANY              in number,       -- .  
      NRRPCONFSCTNMRKCN     in number,       -- .     
      SSOURCE_UNIT          in varchar2      --  
    ) return                varchar2         --      
    is
      SRESULT               PKG_STD.TSTRING; --      
    begin
      /*   */
      SRESULT := '(';
      /*      */
      case SSOURCE_UNIT
        /*   */
        when 'EconomicOperations' then
          /*    " "  " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC_DC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*   / */
        when 'DebitorsCreditorsAccounts' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*     */
        when 'AccountsRemnants' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
        /*  -  */
        when 'ValuesRemnants' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
        /* /  */
        when 'DebitorsCreditorsRemnants' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*   */
        when 'Inventory' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*   */
        when 'ItemsCards' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC_WO_ANL);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
        /*     */
        when 'OperCards' then
          /*    "" */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_ACC);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*   */
        when 'RRPDocuments' then
          /*     */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_RRPCONF);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*      */
        when 'DeclarationIncome' then
          /*     */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_RRPCONF);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_FROM);
          /*    " " */
          MAKE_PRMS_BY_MASK(SPRMS_DESC        => SRESULT,
                            NCOMPANY          => NCOMPANY,
                            NRRPCONFSCTNMRKCN => NRRPCONFSCTNMRKCN,
                            SMASK             => SPRM_MASK_DATE_TO);
        /*   */
        else
          SRESULT := null;
      end case;
      /*    */
      SRESULT := RTRIM(SRESULT, ',');
      /*   */
      SRESULT := SRESULT || ')';
      /*   */
      return SRESULT;
    end SOURCE_UNIT_GET_PRMS;   
  begin
    /*       */
    RREC := GET_RRPCONFSCTNMRKCN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRRPCONFSCTNMRKCN);
    /*        */
    case RREC.SOURCE_TYPE
      /*   */
      when 0 then
        /*      */
        SCN_DESC := SOURCE_UNIT_GET_PRMS(NCOMPANY          => NCOMPANY,
                                         NRRPCONFSCTNMRKCN => RREC.RN,
                                         SSOURCE_UNIT      => RREC.SOURCE_UNIT);
      /*   */
      when 1 then
        /*     */
        RRRPCONFSCTNMRK := GET_RRPCONFSCTNMRK_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RREC.RRPCONFSCTNMRK);
        /*    */
        SCN_DESC := '(' || RRRPCONFSCTNMRK.CODE || ')';
      /*   */
      when 2 then
        /*      */
        SCN_DESC := '(' || PKG_OBJECT_DESC.STORED_NAME(SPACKAGE_NAME => RREC.PKG, SSTORED_NAME => RREC.PRC) || ')';
      /*   */
      when 3 then
        /*    */
        SCN_DESC := '(' || COALESCE(RREC.STATIC_STR,
                                    COALESCE(TO_CHAR(RREC.STATIC_NUM), TO_CHAR(RREC.STATIC_DATE, 'dd.mm.yyyy'))) || ')';
      /*  */
      when 4 then
        /*   */
        SCN_DESC := '(' || RREC.FORMULA || ')';
      else
        SCN_DESC := null;
    end case;
    /*   */
    SRESULT := RRPCONFSCTNMRKCN_GET_SIGN(NSIGN => RREC.SIGN) || ' ' ||
               RRPCONFSCTNMRKCN_GET_ST(NSOURCE_TYPE => RREC.SOURCE_TYPE, SSOURCE_UNIT => RREC.SOURCE_UNIT) || SCN_DESC;
    /*   */
    return SRESULT;
  end RRPCONFSCTNMRKCN_GET_DESC;
  
  /*  .     // */
  function RRPCONFSCTNMRK_GET_ROWCOL
  (
    NRRPCONFSCTN            in number,    -- .  
    NRRPROW                 in number,    -- .  
    NRRPCOLUMN              in number     -- .  
  ) return                  number        -- .  
  is
    NRESULT                 PKG_STD.TREF; -- .  
  begin
    /*    */
    begin
      select T.RN
        into NRESULT
        from RRPCONFSCTNMRK T
       where T.PRN = NRRPCONFSCTN
         and T.RRPROW = NRRPROW
         and T.RRPCOLUMN = NRRPCOLUMN;
    exception
      when others then
        NRESULT := null;
    end;
    /*   */
    return NRESULT;
  end RRPCONFSCTNMRK_GET_ROWCOL;
  
  /*    */
  function RRPCONFSCTNMRK_GET_DESC
  (
    NCOMPANY                in number,        -- .  
    NRRPCONFSCTN            in number,        -- .  
    NRRPROW                 in number,        -- .  
    NRRPCOLUMN              in number         -- .      
  ) return                  varchar2          --   
  is
    SRES                    PKG_STD.TLSTRING; --   
    NRRPCONFSCTNMRK         PKG_STD.TREF;     -- .   
  begin
    /*   */
    NRRPCONFSCTNMRK := RRPCONFSCTNMRK_GET_ROWCOL(NRRPCONFSCTN => NRRPCONFSCTN,
                                                 NRRPROW      => NRRPROW,
                                                 NRRPCOLUMN   => NRRPCOLUMN);
    /*   */
    PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
    /*  */
    PKG_XFAST.DOWN_NODE(SNAME => 'XMARK');
    /*        */
    PKG_XFAST.ATTR(SNAME => 'NRRPROW', NVALUE => NRRPROW);
    PKG_XFAST.ATTR(SNAME => 'NRRPCOLUMN', NVALUE => NRRPCOLUMN);
    /*    */
    for MARK in (select T.RN    NRN,
                        T.CODE  SCODE,
                        T.NAME  SNAME,
                        R.CODE  SRRPROW,
                        RV.CODE SRRPVERSION_ROW,
                        C.CODE  SRRPCOLUMN,
                        CV.CODE SRRPVERSION_COLUMN
                   from RRPCONFSCTNMRK T,
                        RRPROW         R,
                        RRPCOLUMN      C,
                        RRPVERSION     RV,
                        RRPVERSION     CV
                  where T.RN = NRRPCONFSCTNMRK
                    and T.RRPROW = R.RN
                    and T.RRPCOLUMN = C.RN
                    and R.RRPVERSION = RV.RN(+)
                    and C.RRPVERSION = CV.RN(+))
    loop
      /*      */
      PKG_XFAST.ATTR(SNAME => 'NRN', NVALUE => MARK.NRN);
      PKG_XFAST.ATTR(SNAME => 'SCODE', SVALUE => MARK.SCODE);
      PKG_XFAST.ATTR(SNAME => 'SNAME', SVALUE => MARK.SNAME);
      PKG_XFAST.ATTR(SNAME => 'SRRPROW', SVALUE => MARK.SRRPROW);
      PKG_XFAST.ATTR(SNAME => 'SRRPVERSION_ROW', SVALUE => MARK.SRRPVERSION_ROW);
      PKG_XFAST.ATTR(SNAME => 'SRRPCOLUMN', SVALUE => MARK.SRRPCOLUMN);
      PKG_XFAST.ATTR(SNAME => 'SRRPVERSION_COLUMN', SVALUE => MARK.SRRPVERSION_COLUMN);
      /*      */
      for CN in (select T.PRN,
                        T.RN,
                        T.NUMB
                   from RRPCONFSCTNMRKCN T
                  where T.PRN = NRRPCONFSCTNMRK
                  order by T.NUMB asc)
      loop
        /*   */
        PKG_XFAST.DOWN_NODE(SNAME => 'CONSTITUTION');
        PKG_XFAST.ATTR(SNAME => 'NPRN', NVALUE => CN.PRN);
        PKG_XFAST.ATTR(SNAME => 'NRN', NVALUE => CN.RN);
        PKG_XFAST.ATTR(SNAME => 'SNUMB', SVALUE => CN.NUMB);
        PKG_XFAST.ATTR(SNAME  => 'SDESC',
                       SVALUE => RRPCONFSCTNMRKCN_GET_DESC(NCOMPANY => NCOMPANY, NRRPCONFSCTNMRKCN => CN.RN));
        PKG_XFAST.UP();
      end loop;
    end loop;
    PKG_XFAST.UP();
    /*   */
    SRES := PKG_XFAST.SERIALIZE_TO_VARCHAR();
    /*   */
    PKG_XFAST.EPILOGUE();
    /*   */
    return SRES;
  end RRPCONFSCTNMRK_GET_DESC;
  
  /*      ,    */
  procedure RRPCONFSCTNMRK_BUILD_CODE_NAME
  (
    NCOMPANY                in number,           -- .  
    NRRPCONFSCTN            in number,           -- .   
    NRRPROW                 in number,           -- .   
    NRRPCOLUMN              in number,           -- .   
    SCODE                   in out varchar2,     --    (null -   ,  -   )
    SNAME                   in out varchar2      --    (null -   ,  -   )
  )
  is
    RRRPCONFSCTN            RRPCONFSCTN%rowtype; --   
    RRRPROW                 RRPROW%rowtype;      --   
    RRRPCOLUMN              RRPCOLUMN%rowtype;   --   
  begin
    /*   ,      */
    if (SCODE is null) then
      /*   ,    */
      RRRPCONFSCTN := GET_RRPCONFSCTN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRRPCONFSCTN);
      RRRPROW      := GET_RRPROW_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRRPROW);
      RRRPCOLUMN   := GET_RRPCOLUMN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRRPCOLUMN);
      /*   */
      P_RRPCONFSCTNMRK_MAKE_CODE(SRRPCONFSCTN => RRRPCONFSCTN.CODE,
                                 SRRPROW      => RRRPROW.CODE,
                                 SRRPCOLUMN   => RRRPCOLUMN.CODE,
                                 SCODE        => SCODE);
    end if;
    /*   ,      */
    if (SNAME is null) then
      P_RRPCONFSCTNMRK_MAKE_NAME(NCOMPANY            => NCOMPANY,
                                 NRRPROW             => NRRPROW,
                                 NRRPCOLUMN          => NRRPCOLUMN,
                                 NCHANGE_NAME        => 1,
                                 NCHANGE_NAME_PARENT => 0,
                                 SNAME               => SNAME);
    end if;
  end RRPCONFSCTNMRK_BUILD_CODE_NAME;
  
  /*   ,   */
  procedure RRPCONFSCTNMRK_JOINS
  (
    NCOMPANY                in number,              -- .  
    NRRPROW                 in number,              -- .  
    SRRPROW                 in varchar2,            --   (,   .  )
    SRRPVERSION_ROW         in varchar2,            --    (,   .  )
    NRRPCOLUMN              in number,              -- .  
    SRRPCOLUMN              in varchar2,            --   (,   .  )
    SRRPVERSION_COLUMN      in varchar2,            --    (,   .  )
    RRRPROW                 out RRPROW%rowtype,     --    
    RRRPVERSION_ROW         out RRPVERSION%rowtype, --     
    RRRPCOLUMN              out RRPCOLUMN%rowtype,  --    
    RRRPVERSION_COLUMN      out RRPVERSION%rowtype  --     
  )
  is
    NRRPVERSION             PKG_STD.TREF;           -- .   /
    NRRPROW_                PKG_STD.TREF;           --   .  
    NRRPCOLUMN_             PKG_STD.TREF;           --   .  
  begin
    /*         */
    if (NRRPROW is null) then
      FIND_RRPVERSION_CODE(NFLAG_SMART  => 0,
                           NFLAG_OPTION => 1,
                           NCOMPANY     => NCOMPANY,
                           SCODE        => SRRPVERSION_ROW,
                           NRN          => NRRPVERSION);
      FIND_RRPROW_CODE(NFLAG_SMART  => 0,
                       NFLAG_OPTION => 0,
                       NCOMPANY     => NCOMPANY,
                       NRRPVERSION  => NRRPVERSION,
                       SCODE        => SRRPROW,
                       NRN          => NRRPROW_);
    else
      NRRPROW_ := NRRPROW;
    end if;
    RRRPROW         := GET_RRPROW_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRRPROW_);
    RRRPVERSION_ROW := GET_RRPVERSION_ID(NFLAG_SMART => 1, NCOMPANY => NCOMPANY, NRN => RRRPROW.RRPVERSION);
    /*         */
    if (NRRPCOLUMN is null) then
      FIND_RRPVERSION_CODE(NFLAG_SMART  => 0,
                           NFLAG_OPTION => 1,
                           NCOMPANY     => NCOMPANY,
                           SCODE        => SRRPVERSION_COLUMN,
                           NRN          => NRRPVERSION);
      FIND_RRPCOLUMN_CODE(NFLAG_SMART  => 0,
                          NFLAG_OPTION => 0,
                          NCOMPANY     => NCOMPANY,
                          NRRPVERSION  => NRRPVERSION,
                          SCODE        => SRRPCOLUMN,
                          NRN          => NRRPCOLUMN_);
    else
      NRRPCOLUMN_ := NRRPCOLUMN;
    end if;
    RRRPCOLUMN         := GET_RRPCOLUMN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRRPCOLUMN_);
    RRRPVERSION_COLUMN := GET_RRPVERSION_ID(NFLAG_SMART => 1, NCOMPANY => NCOMPANY, NRN => RRRPCOLUMN.RRPVERSION);
  end RRPCONFSCTNMRK_JOINS;
    
  /*      */
  procedure RRPCONFSCTNMRK_INSERT
  (
    NPRN                    in number,                             -- .  
    SCODE                   in varchar2,                           --   
    SNAME                   in varchar2,                           --   
    NRRPROW                 in number,                             -- .  
    SRRPROW                 in varchar2,                           --   (,   .  )
    SRRPVERSION_ROW         in varchar2,                           --    (,   .  )
    NRRPCOLUMN              in number,                             -- .  
    SRRPCOLUMN              in varchar2,                           --   (,   .  )
    SRRPVERSION_COLUMN      in varchar2,                           --    (,   .  )
    NRN                     out number                             -- .   
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    RRRPROW                 RRPROW%rowtype;                        --    
    RRRPVERSION_ROW         RRPVERSION%rowtype;                    --     
    RRRPCOLUMN              RRPCOLUMN%rowtype;                     --    
    RRRPVERSION_COLUMN      RRPVERSION%rowtype;                    --     
    SCODE_                  PKG_STD.TSTRING;                       --    
    SNAME_                  PKG_STD.TSTRING;                       --    
  begin
    /*   (, ,   ..)  ,    */
    RRPCONFSCTNMRK_JOINS(NCOMPANY           => NCOMPANY,
                         NRRPROW            => NRRPROW,
                         SRRPROW            => SRRPROW,
                         SRRPVERSION_ROW    => SRRPVERSION_ROW,
                         NRRPCOLUMN         => NRRPCOLUMN,
                         SRRPCOLUMN         => SRRPCOLUMN,
                         SRRPVERSION_COLUMN => SRRPVERSION_COLUMN,
                         RRRPROW            => RRRPROW,
                         RRRPVERSION_ROW    => RRRPVERSION_ROW,
                         RRRPCOLUMN         => RRRPCOLUMN,
                         RRRPVERSION_COLUMN => RRRPVERSION_COLUMN);
    /*     ,      */
    SCODE_ := SCODE;
    SNAME_ := SNAME;
    RRPCONFSCTNMRK_BUILD_CODE_NAME(NCOMPANY     => NCOMPANY,
                                   NRRPCONFSCTN => NPRN,
                                   NRRPROW      => RRRPROW.RN,
                                   NRRPCOLUMN   => RRRPCOLUMN.RN,
                                   SCODE        => SCODE_,
                                   SNAME        => SNAME_);
    /*   */
    P_RRPCONFSCTNMRK_INSERT(NCOMPANY           => NCOMPANY,
                            NPRN               => NPRN,
                            NNUMB              => F_RRPCONFSCTNMRK_NEXT_NUMB(NCOMPANY => NCOMPANY, NPRN => NPRN),
                            SCODE              => SCODE_,
                            SNAME              => SNAME_,
                            SRRPROW            => RRRPROW.CODE,
                            SRRPVERSION_ROW    => RRRPVERSION_ROW.CODE,
                            SRRPCOLUMN         => RRRPCOLUMN.CODE,
                            SRRPVERSION_COLUMN => RRRPVERSION_COLUMN.CODE,
                            SPKG_ROW           => null,
                            SPRC_ROW           => null,
                            SPKG_COL           => null,
                            SPRC_COL           => null,
                            SRRPPRM            => null,
                            NIGNORE_ZOOM       => 0,
                            NIGNORE_SHARP      => 0,
                            SCLSF_CODE         => null,
                            SNOTE              => null,
                            NDUP_RN            => null,
                            NRN                => NRN);
  end RRPCONFSCTNMRK_INSERT;
  
  /*      */
  procedure RRPCONFSCTNMRK_UPDATE
  (
    NRN                     in number,                             -- .               
    SCODE                   in varchar2,                           --   
    SNAME                   in varchar2,                           --   
    SRRPROW                 in varchar2,                           --  
    SRRPVERSION_ROW         in varchar2,                           --   
    SRRPCOLUMN              in varchar2,                           --  
    SRRPVERSION_COLUMN      in varchar2                            --   
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    RMRK                    RRPCONFSCTNMRK%rowtype;                --     
    RRRPPRM                 RRPPRM%rowtype;                        --     
    RRRPROW                 RRPROW%rowtype;                        --    
    RRRPVERSION_ROW         RRPVERSION%rowtype;                    --     
    RRRPCOLUMN              RRPCOLUMN%rowtype;                     --    
    RRRPVERSION_COLUMN      RRPVERSION%rowtype;                    --     
    SCODE_                  PKG_STD.TSTRING;                       --    
    SNAME_                  PKG_STD.TSTRING;                       --    
  begin
    /*     */
    RMRK := GET_RRPCONFSCTNMRK_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRN);
    /*   (, ,   ..)  ,    */
    RRPCONFSCTNMRK_JOINS(NCOMPANY           => NCOMPANY,
                         NRRPROW            => null,
                         SRRPROW            => SRRPROW,
                         SRRPVERSION_ROW    => SRRPVERSION_ROW,
                         NRRPCOLUMN         => null,
                         SRRPCOLUMN         => SRRPCOLUMN,
                         SRRPVERSION_COLUMN => SRRPVERSION_COLUMN,
                         RRRPROW            => RRRPROW,
                         RRRPVERSION_ROW    => RRRPVERSION_ROW,
                         RRRPCOLUMN         => RRRPCOLUMN,
                         RRRPVERSION_COLUMN => RRRPVERSION_COLUMN);
    /*     ,      */
    SCODE_ := SCODE;
    SNAME_ := SNAME;
    RRPCONFSCTNMRK_BUILD_CODE_NAME(NCOMPANY     => NCOMPANY,
                                   NRRPCONFSCTN => RMRK.PRN,
                                   NRRPROW      => RRRPROW.RN,
                                   NRRPCOLUMN   => RRRPCOLUMN.RN,
                                   SCODE        => SCODE_,
                                   SNAME        => SNAME_);
    /*    ,     (   , ..      ) */
    if (RMRK.RRPPRM is not null) then
      RRRPPRM := GET_RRPPRM_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RMRK.RRPPRM);
    else
      RRRPPRM.CODE := null;
    end if;
    /*   */
    P_RRPCONFSCTNMRK_UPDATE(NRN                => RMRK.RN,
                            NCOMPANY           => NCOMPANY,
                            NNUMB              => RMRK.NUMB,
                            SCODE              => SCODE_,
                            SNAME              => SNAME_,
                            SRRPROW            => SRRPROW,
                            SRRPVERSION_ROW    => SRRPVERSION_ROW,
                            SRRPCOLUMN         => SRRPCOLUMN,
                            SRRPVERSION_COLUMN => SRRPVERSION_COLUMN,
                            SPKG_ROW           => RMRK.PKG_ROW,
                            SPRC_ROW           => RMRK.PRC_ROW,
                            SPKG_COL           => RMRK.PKG_COL,
                            SPRC_COL           => RMRK.PRC_COL,
                            SRRPPRM            => RRRPPRM.CODE,
                            NIGNORE_ZOOM       => RMRK.IGNORE_ZOOM,
                            NIGNORE_SHARP      => RMRK.IGNORE_SHARP,
                            SCLSF_CODE         => RMRK.CLSF_CODE,
                            NFORMULA_UPDATE    => 1,
                            SNOTE              => RMRK.NOTE);
  end RRPCONFSCTNMRK_UPDATE;
  
  /*      */
  procedure RRPCONFSCTNMRK_DELETE
  (        
    NRN                     in number   -- .   
  )
  is
  begin
    /*   */
    P_RRPCONFSCTNMRK_DELETE(NCOMPANY => GET_SESSION_COMPANY(), NRN => NRN);
  end RRPCONFSCTNMRK_DELETE;

  /*     */
  procedure RRPCONFSCTN_GET
  (
    NRRPCONFSCTN            in number,                             -- .      
    NROW_ORDER              in number := 0,                        --    (0 -  , 1 -  , 2 -  )
    NCOL_ORDER              in number := 0,                        --    (0 -  , 1 -  , 2 -  )
    COUT                    out clob                               --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    RDG                     PKG_P8PANELS_VISUAL.TDG;               --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TDG_ROW;           --      
    ICURSOR                 integer;                               --    
    NROW_RN                 PKG_STD.TREF;                          -- .  
    SROW_NAME               PKG_STD.TSTRING;                       --  
    NCOL_RN                 PKG_STD.TREF;                          -- .  
    
    /*     ""  / */
    function TABCOL_ROWCOL_CODE_GET
    (
      STABLE                in varchar2 --  (RRPROW -  , RRPCOLUMN -  )
    ) return                varchar2    --      ""
    is
    begin
      /*     */
      if (STABLE = 'RRPCOLUMN') then
        /*   */
        return 'COLUMN_CODE';
      elsif (STABLE = 'RRPROW') then
        /*   */
        return 'ROW_CODE';
      else
        /*   */
        P_EXCEPTION(0,
                    ' "%s"  .',
                    COALESCE(STABLE, '< >'));
      end if;
    end TABCOL_ROWCOL_CODE_GET;
    
    /*     SQL-  / */
    function ORDER_CLAUSE_GET
    (
      STABLE                in varchar2,     --  (RRPROW -  , RRPCOLUMN -  )
      NORDER                in number,       --   (0 -  , 1 -  , 2 -  )      
      SALIAS                in varchar2      --     
    ) return                varchar2         --   
    is
      SRESULT               PKG_STD.TSTRING; --   
      STABLE_COLUMN_CODE    PKG_STD.TSTRING; --   ,  
    begin
      /*   ,   */
      STABLE_COLUMN_CODE := TABCOL_ROWCOL_CODE_GET(STABLE => STABLE);
      /*    */
      case NORDER
        /*  -   -  */
        when 1 then
          SRESULT := PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.' || STABLE_COLUMN_CODE || ', 40, ''0''),' || SALIAS ||
                     '.SORT_NUMB,' || PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.CODE, 20, ''0'')';
        /*  -   -  */
        when 2 then
          SRESULT := PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.CODE, 20, ''0''),' || SALIAS || '.SORT_NUMB,' ||
                     PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.' || STABLE_COLUMN_CODE || ', 40, ''0'')';
        /*   -  -  */
        else
          SRESULT := SALIAS || '.SORT_NUMB,' || PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.' || STABLE_COLUMN_CODE ||
                     ', 40, ''0''),' || PKG_SQL_BUILD.LPAD_() || '(' || SALIAS || '.CODE, 20, ''0'')';
      end case;
      /*   */
      return SRESULT;
    end ORDER_CLAUSE_GET;
    
    /*    /  */
    procedure OPEN_ROWS_COLS_CUR
    (
      NRRPCONFSCTN          in number,       -- .      
      STABLE                in varchar2,     --  (RRPROW -  , RRPCOLUMN -  )
      NORDER                in number,       --   (0 -  , 1 -  , 2 -  )
      ICURSOR               in out integer   --  
    ) 
    is
      CSQL                  clob;            -- 
      SORDERS               PKG_STD.TSTRING; --  
    begin
      /*     */
      if (PKG_SQL_DML.IS_OPEN(ICURSOR => ICURSOR)) then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
      end if;
      /*    */
      SORDERS := ORDER_CLAUSE_GET(STABLE => STABLE, NORDER => NORDER, SALIAS => 'T');
      /*   */
      CSQL := PKG_SQL_BUILD.COMPATIBLE();
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => 'select T.RN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '       T.NAME');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '  from RRPCONFSCTNMRK M,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '       ' || STABLE || ' T');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' where M.PRN = ' || TO_CHAR(NRRPCONFSCTN));
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '   and T.RN = M.' || STABLE);
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' group by T.RN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          T.CODE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          T.NAME,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          T.' || TABCOL_ROWCOL_CODE_GET(STABLE => STABLE) || ',');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          T.SORT_NUMB');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => ' order by ' || SORDERS);
      /*   */
      ICURSOR := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
      PKG_SQL_DML.PARSE(ICURSOR => ICURSOR, SQUERY => CSQL);
      /*     */
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 1);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 2);
      /*     */
      if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR) = 0) then
        null;
      end if;
    end OPEN_ROWS_COLS_CUR;
       
    /*       .    */
    function DG_COL_NAME_BY_RRPCOLUMN
    (
      NRRPCOLUMN            in number   -- .  
    ) return                varchar2    --     
    is
    begin
      return 'SCOL_' || TO_CHAR(NRRPCOLUMN);
    end DG_COL_NAME_BY_RRPCOLUMN;
    
    /*  .         */
    function RRPCOLUMN_BY_DG_COL_NAME
    (
      SDG_COL_NAME          in varchar2 --    
    ) return                number      -- .  
    is
    begin
      return TO_NUMBER(replace(SDG_COL_NAME, 'SCOL_', ''));
    end RRPCOLUMN_BY_DG_COL_NAME;
    
    /*     */
    procedure COLUMNS_INIT
    (
      RDG                   in out nocopy PKG_P8PANELS_VISUAL.TDG, --  
      NRRPCONFSCTN          in number,                             -- .  
      NCOL_ORDER            in number,                             --    (0 -  , 1 -  , 2 -  )
      NCOL_WIDTH            in number                              --   ()
    )
    is
      ICURSOR               integer;                               --        
      NCOL_RN               PKG_STD.TREF;                          -- .  
      SCOL_NAME             PKG_STD.TSTRING;                       --  
    begin
      /*        */
      PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                          SNAME      => 'SROW_NAME',
                                          SCAPTION   => ' ',
                                          SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                          NWIDTH     => NCOL_WIDTH);
      /*       -      */
      OPEN_ROWS_COLS_CUR(NRRPCONFSCTN => NRRPCONFSCTN, STABLE => 'RRPCOLUMN', NORDER => NCOL_ORDER, ICURSOR => ICURSOR);
      /*     */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*  .   */
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 1, NVALUE => NCOL_RN);
        /*    */
        PKG_SQL_DML.COLUMN_VALUE_STR(ICURSOR => ICURSOR, IPOSITION => 2, SVALUE => SCOL_NAME);
        /*   */
        PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                            SNAME      => DG_COL_NAME_BY_RRPCOLUMN(NRRPCOLUMN => NCOL_RN),
                                            SCAPTION   => SCOL_NAME,
                                            SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                            NWIDTH     => NCOL_WIDTH);
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
    exception
      when others then
        if (PKG_SQL_DML.IS_OPEN(ICURSOR => ICURSOR)) then
          PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
        end if;
        raise;
    end COLUMNS_INIT;
  begin
    /*    */
    for S in (select T.RN NRN
                from RRPCONFSCTN T
               where T.RN = NRRPCONFSCTN
                 and exists (select null from RRPCONFSCTNMRK M where M.PRN = T.RN)
                 and exists (select null from V_USERPRIV UP where UP.CATALOG = T.CRN))
    loop
      /*    */
      RDG := PKG_P8PANELS_VISUAL.TDG_MAKE(BFIXED_HEADER => true, NFIXED_COLUMNS => 1);
      /*     */
      COLUMNS_INIT(RDG => RDG, NRRPCONFSCTN => S.NRN, NCOL_ORDER => NCOL_ORDER, NCOL_WIDTH => NMRKS_DG_COL_WIDTH);
      /*        */
      OPEN_ROWS_COLS_CUR(NRRPCONFSCTN => NRRPCONFSCTN, STABLE => 'RRPROW', NORDER => NROW_ORDER, ICURSOR => ICURSOR);
      /*     */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*  .   */
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 1, NVALUE => NROW_RN);
        /*    */
        PKG_SQL_DML.COLUMN_VALUE_STR(ICURSOR => ICURSOR, IPOSITION => 2, SVALUE => SROW_NAME);
        /*    */
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SROW_NAME', SVALUE => SROW_NAME, BCLEAR => true);
        /*      */
        for I in RDG.RCOL_DEFS.FIRST .. RDG.RCOL_DEFS.LAST
        loop
          /*   -      */
          if (I > RDG.RCOL_DEFS.FIRST) then
            /*  .      */
            NCOL_RN := RRPCOLUMN_BY_DG_COL_NAME(SDG_COL_NAME => RDG.RCOL_DEFS(I).SNAME);
            /*     */
            PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW   => RDG_ROW,
                                                SNAME  => RDG.RCOL_DEFS(I).SNAME,
                                                SVALUE => RRPCONFSCTNMRK_GET_DESC(NCOMPANY     => NCOMPANY,
                                                                                  NRRPCONFSCTN => S.NRN,
                                                                                  NRRPROW      => NROW_RN,
                                                                                  NRRPCOLUMN   => NCOL_RN));
          end if;
        end loop;
        /*     */
        PKG_P8PANELS_VISUAL.TDG_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
      /*   */
      COUT := PKG_P8PANELS_VISUAL.TDG_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
    end loop;
  exception
    when others then
      if (PKG_SQL_DML.IS_OPEN(ICURSOR => ICURSOR)) then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
      end if;
      raise;
  end RRPCONFSCTN_GET;

  /*     */
  procedure RRPCONFSCTN_INSERT
  (
    NPRN                    in number,                             -- .     
    SCODE                   in varchar2,                           -- 
    SNAME                   in varchar2,                           -- 
    NRN                     out number                             -- .   
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
  begin
    /*   */
    P_RRPCONFSCTN_INSERT(NCOMPANY            => NCOMPANY,
                         NPRN                => NPRN,
                         SCODE               => SCODE,
                         SNAME               => SNAME,
                         SRRPCONFSCTN        => null,
                         SRRPPRMGRP          => null,
                         SNOTE               => null,
                         NHTML_HIDE          => 0,
                         NHTML_HIDE_NAME_COL => 0,
                         NHTML_MAKE_HIER_GRP => 0,
                         SCLSF_CODE          => null,
                         NLINKS_UPDATE       => 0,
                         NDUP_RN             => null,
                         NRN                 => NRN);
  end RRPCONFSCTN_INSERT;
  
  /*     */
  procedure RRPCONFSCTN_UPDATE
  (
    NRN                     in number,                             -- .  
    SCODE                   in varchar2,                           --  
    SNAME                   in varchar2                            --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    RRES                    RRPCONFSCTN%rowtype;                   --      
    RRRPCONFSCTN            RRPCONFSCTN%rowtype;                   --      
    RRRPPRMGRP              RRPPRMGRP%rowtype;                     --     
  begin
    /*    */
    RRES := GET_RRPCONFSCTN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => NRN);
    /*     */
    if (RRES.RRPCONFSCTN is not null) then
      RRRPCONFSCTN := GET_RRPCONFSCTN_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RRES.RRPCONFSCTN);
    end if;
    /*     */
    if (RRES.RRPPRMGRP is not null) then
      RRRPPRMGRP := GET_RRPPRMGRP_ID(NFLAG_SMART => 0, NCOMPANY => NCOMPANY, NRN => RRES.RRPPRMGRP);
    end if;
    /*   */
    P_RRPCONFSCTN_UPDATE(NRN                 => RRES.RN,
                         NCOMPANY            => NCOMPANY,
                         SCODE               => SCODE,
                         SNAME               => SNAME,
                         SRRPCONFSCTN        => RRRPCONFSCTN.CODE,
                         SRRPPRMGRP          => RRRPPRMGRP.CODE,
                         SNOTE               => RRES.NOTE,
                         NHTML_HIDE          => RRES.HTML_HIDE,
                         NHTML_HIDE_NAME_COL => RRES.HTML_HIDE_NAME_COL,
                         NHTML_MAKE_HIER_GRP => RRES.HTML_MAKE_HIER_GRP,
                         SCLSF_CODE          => RRES.CLSF_CODE,
                         NFORMULA_UPDATE     => 1,
                         NMARK_UPDATE        => 1);
  end RRPCONFSCTN_UPDATE;
  
  /*     */
  procedure RRPCONFSCTN_DELETE
  (
    NRN                     in number   -- .  
  )
  is
  begin
    /*   */
    P_RRPCONFSCTN_DELETE(NCOMPANY => GET_SESSION_COMPANY(), NRN => NRN);
  end RRPCONFSCTN_DELETE;

  /*      */
  procedure RRPCONF_GET
  (
    NRRPCONF                in number,                             -- .     
    COUT                    out clob                               --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    SNAME_SHORT             PKG_STD.TSTRING;                       --   
  begin
    /*  XML   */
    PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
    PKG_XFAST.DOWN_NODE(SNAME => 'XDATA');
    /*    */
    for CONF in (select C.RN   NRN,
                        C.NAME SNAME
                   from RRPCONF C
                  where C.RN = NRRPCONF
                    and exists (select null from V_USERPRIV UP where UP.CATALOG = C.CRN))
    loop
      /*       */
      PKG_XFAST.DOWN_NODE(SNAME => 'XCONF');
      PKG_XFAST.ATTR(SNAME => 'SNAME', SVALUE => CONF.SNAME);
      PKG_XFAST.UP();
      /*    */
      for C in (select T.RN   NRN,
                       T.CODE SCODE,
                       T.NAME SNAME
                  from RRPCONFSCTN T
                 where T.PRN = CONF.NRN
                   and exists (select null from V_USERPRIV UP where UP.CATALOG = T.CRN)
                 order by T.CODE,
                          T.NAME)
      loop
        /*    */
        SNAME_SHORT := SUBSTR(C.SNAME, 1, NSECTION_NAME_MAX_LEN);
        if (LENGTH(C.SNAME) > NSECTION_NAME_MAX_LEN) then
          SNAME_SHORT := SNAME_SHORT || '...';
        end if;
        /*   XML     */
        PKG_XFAST.DOWN_NODE(SNAME => 'XSECTIONS');
        PKG_XFAST.ATTR(SNAME => 'NRN', NVALUE => C.NRN);
        PKG_XFAST.ATTR(SNAME => 'SCODE', SVALUE => C.SCODE);
        PKG_XFAST.ATTR(SNAME => 'SNAME', SVALUE => C.SNAME);
        PKG_XFAST.ATTR(SNAME => 'SNAME_SHORT', SVALUE => SNAME_SHORT);
        PKG_XFAST.ATTR(SNAME  => 'NDELETE_ALLOW',
                       NVALUE => UTL_UNIT_ACTION_GET_ALLOW(NCOMPANY => NCOMPANY,
                                                           NRN      => C.NRN,
                                                           SUNIT    => SUNIT_RRPCONFSCTN,
                                                           SACTION  => SACTION_DELETE));
        PKG_XFAST.UP();
      end loop;
    end loop;
    /*   */
    PKG_XFAST.UP();
    /*   */
    COUT := PKG_XFAST.SERIALIZE_TO_CLOB();
    /*   XML */
    PKG_XFAST.EPILOGUE();
  end RRPCONF_GET;
  
end PKG_P8PANELS_RRPCONFED;
/
